100 REMark *
110 REMark * BASIC Configuration Extensions (v1.12)
120 REMark * by Oliver Fink    18/06/90
130 REMark *
140 REMark * Jobname : BasConfig
150 REMark *
160 REMark * Updated : 05/04/94 - Norman Dunbar
170 REMark *
175 REMark * Further Improved : 16/3/98 - Rich Mellor
177 REMark *
180 REMark * QLib Information : no cmdline, no windows, no lines, no names
190 REMark *
200 REMark * assembler moduls : BasConfig_cfg         - by O.Fink
205 REMark *                    chbase_rext           - S.Goodwin
210 REMark *                    (QLib runtimes)
220 REMark *
230 :
240 REMark $$asmb=Win1_PROGS_BASCONFIG_chbase_rext,0,272
250 REMark $$asmb=WIN1_PROGS_BASCONFIG_basConfig_cfg,0,12
260 :
1000 REMark * draw main window and title
1005 OPEN #1,'con_2x1a0x0'
1010 IF C_CODE(1)=1 THEN ch=1:OUTLN 400,140,56,40;4,4 : ELSE ch=2:OPEN #2,'con_2x1a0x0':WINDOW #2;400,140,56,40
1020 PAPER #ch;7:BORDER #ch;1,0:CLS #ch
1030 PAPER #ch;92 : INK #ch;0
1040 CHAR_INC #ch;6,12 : CLS #ch;3
1050 PAPER #ch;7:CURSOR #ch;90,1:PRINT #ch;" Configuration Extensions Level 1 "
1060 WINDOW 396,127,58,52 : PAPER 7:INK 0:BORDER 1,4 : CLS
1070 BORDER 2:CSIZE 0,0
1080 :
1090 REMark * print some information for the user
1100 PRINT "This program, supplied by QLaboratories, produces a file that  "
1110 PRINT "allows the use of the standard QJump Configuration program in  "
1120 PRINT "conjunction with Q_Liberated SuperBASIC programs.             "
1122 PRINT
1125 PRINT 'Bug fix & LONG WORD handling by Norman Dunbar, 5th April 1994.'
1130 PRINT
1131 PRINT 'Additional Bug Fixes and Special String Handling by Rich Mellor, 4th March 1998.'
1132 PRINT
1133 base=-1
1135 :
1137 REMark * repeat all this over and over again
1138 REPeat all
1139    IF base<>-1 THEN RECHP base
1140    PRINT
1150    :
1160    REMark * enter total number of items
1170    REPeat chk
1180       nr$=accept$("Enter the total number of configuration items required for\your file or press ESC to quit","",5,0)
1190       IF nr$=CHR$(27) THEN EXIT all
1200       nr_items='0'&nr$
1210       IF nr_items>0 THEN EXIT chk
1220       pr_error nr$&" - not possible"
1230    END REPeat chk
1240    :
1250    :
1260    REMark * allocate space and load binary file to append data
1270    dev1$=C_STRG$(1):bin_file$=dev1$&"cfg_bin"
1280    base=ALCHP(10240)
1290    :
1300    REPeat chk
1310       IF FTEST(bin_file$)=0 THEN EXIT chk
1320       pr_error bin_file$&" - not found on data device"
1330       IF accept$("Insert disk into drive "&dev1$&" and press return","",0,0)=CHR$(27) THEN NEXT all
1340    END REPeat chk
1350    bin_len=FLEN(\bin_file$)
1360    LBYTES bin_file$,base
1370    adr_list=base+bin_len
1375 REMark Check for Config version 01
1377    check$='<<QCFX>>'
1378    check$=check$&'01'
1380    REPeat test_loop
1382      FOR i=-10 TO -1
1385        IF PEEK(adr_list+i)<>CODE(check$(11+i)):EXIT i
1386      NEXT i
1387        EXIT test_loop
1388      END FOR i
1389      adr_list=adr_list-1
1390    END REPeat test_loop
1395    :
1397    adr_list=even(adr_list)
1400    REMark * get software name
1410    PRINT
1420    sw_name$=accept$("Enter software name","",25,3)
1430    IF sw_name$=CHR$(27) THEN NEXT all
1440    pk_$ adr_list,sw_name$
1450    :
1460    REMark * get software version number
1470    PRINT
1480    sw_vers$=accept$("Enter software version","1.00",8,3)
1490    IF sw_vers$=CHR$(27) THEN NEXT all
1500    pk_$ adr_list,sw_vers$
1505    adr_list=even(adr_list)
1510    :
1520    REMark * position where relative pointer point to
1530    adr_items=adr_list+12*nr_items+4
1540    :
1550    REMark * select appropriate type of configuration item
1560    FOR item=1 TO nr_items
1570       PRINT
1580       type=select_it("Select type for item #"&item,"String\Char\Code\Select\Byte\Word\Long word")
1590       SELect ON type
1600          =0 : cfg_string
1610          =1 : cfg_char
1620          =2 : cfg_code
1630          =3 : pr_error "select - not implemented yet":item=item-1:NEXT item
1640          =4 : cfg_values  8
1650          =5 : cfg_values 10
1660          =6 : cfg_values 12
1670          =27: NEXT all
1680       END SELect
1690    END FOR item
1695    pk_w adr_list,-1
1700    :
1710    PRINT
1720    file_name$=C_STRG$(2)
1730    REPeat chk
1740       file_name$=accept$("Enter file name where the binary configuration file\will be written to",file_name$,32,3)
1750       IF file_name$=CHR$(27) THEN NEXT all
1760       ferr=FTEST(file_name$)
1770       IF ferr=-7 THEN EXIT chk
1780       SELect ON ferr
1800          =-20: pr_error "read only permitted"
1810          =0  : over_w$=accept$(file_name$&" already exists\OK to overwrite ... Y/N","",1,-1)
1820                IF over_w$=='Y' THEN EXIT chk
1830          =-9 : pr_error "file or device in use"
1840       END SELect
1850    END REPeat chk
1860    SBYTES_O file_name$,base,adr_items-base
1870 END REPeat all
1880 :
1900 STOP
2000 :
2010 REMark ----- poke procedures -----------------------------------------
2020 :
2030 DEFine PROCedure pk_b(adr,val)
2040    POKE adr,val:adr=adr+1
2050 END DEFine
2060 :
2070 DEFine PROCedure pk_w(adr,val)
2080    adr=even(adr)
2090    POKE_W adr,val : adr=adr+2
2100 END DEFine
2110 :
2120 DEFine PROCedure pk_l(adr,val)
2130    adr=even(adr)
2140    POKE_L adr,val : adr=adr+4
2150 END DEFine
2160 :
2170 DEFine PROCedure pk_wr(adr,val)
2175    adr=even(adr)
2180    pk_w adr,val-adr
2190 END DEFine
2200 :
2210 DEFine PROCedure pk_$(adr,s$)
2220    LOCal l,i
2230    l=LEN(s$)
2240    pk_w adr,l
2250    FOR i=1 TO l:pk_b adr,CODE(s$(i))
2260    adr=even(adr)
2270 END DEFine
2280 :
2290 DEFine FuNction even(x)
2300    IF x/2<>INT(x/2) THEN RETurn x+1:ELSE RETurn x
2310 END DEFine
2500 REMark ----- special config procedures ---------------------------------
2510 DEFine FuNction it_desc
2520    LOCal loop1,desc$,desc1$
2522    desc_adr=even(adr_items)
2523    STRIP 7
2525    PRINT "Enter description text for the item. Press return for a new"\"line, or ESC in a new line when ready>"\\
2535    desc$=accept$("","",62,3)
2537    REPeat loop1
2538       PRINT
2539       desc1$=accept$("","",62,3)
2540       IF desc1$=CHR$(27) THEN EXIT loop1
2545       desc$=desc$&CHR$(10)&desc1$
2547    END REPeat loop1
2550    pk_$ adr_items,desc$
2590    RETurn desc_adr
2600 END DEFine
2620 :
2640 DEFine PROCedure cfg_values(type)
2660    LOCal b_val$,b_val,b_adr,type$,r1
2661    SELect ON type
2662       =8:type$="byte":r1=255
2663       =10:type$="word":r1=65535
2667       =12: type$ = 'long': r1 = 2.147483E9: REMark Not quite 2^31-1
2671    END SELect
2680    pk_b adr_list,type
2690    PRINT
2700    pk_b adr_list,CODE(accept$("Type selection keystroke for the item","",1,-1))
2720    PRINT
2740    REPeat chk
2760       b_val$=accept$("Enter initial value for "&type$&" (0-"&r1&")","0",LEN(r1),0)
2780       IF b_val$=CHR$(27) THEN RETurn
2800       b_val="0"&b_val$
2820       SELect ON b_val=0 TO r1:EXIT chk
2840       pr_error b_val$&" - not possible"
2860    END REPeat chk
2870    PRINT
2880    b_adr=adr_items
2900    value_poke type, adr_items, b_val
2920    pk_wr adr_list,b_adr
2940    pk_w adr_list,0 : pk_w adr_list,0
2960    pk_wr adr_list,it_desc
2965    REPeat chk
2970       b_val$=accept$("Enter minimum value allowed","0",LEN(r1),0)
2980       IF b_val$=CHR$(27) THEN RETurn
2990       b_val="0"&b_val$
3000       SELect ON b_val=0 TO r1:EXIT chk
3010       pr_error b_val$&" - not possible"
3020    END REPeat chk
3025    PRINT
3030    b_adr=adr_items
3040    value_poke type, adr_items, b_val
3050    pk_wr adr_list,b_adr
3060    REPeat chk
3070       b_val$=accept$("Enter maximum value allowed",r1,LEN(r1),0)
3080       IF b_val$=CHR$(27) THEN RETurn
3090       b_val="0"&b_val$
3100       SELect ON b_val=0 TO r1:EXIT chk
3110       pr_error b_val$&" - not possible"
3120    END REPeat chk
3140    value_poke type, adr_items, b_val
3150 END DEFine
3160 :
3170 DEFine PROCedure cfg_string
3180    LOCal s_adr,s_num,s_num$
4000    pk_b adr_list,0
4005    PRINT
4010    pk_b adr_list,CODE(accept$("Type selection keystroke for the item","",1,-1))
4020    PRINT
4022    REPeat chk
4025       s_num$=accept$("Enter maximum length of the string","62",3,3)
4027       IF s_num$=CHR$(27) THEN EXIT chk
4028       s_num="0"&s_num$
4030       SELect ON s_num=2 TO 62:EXIT chk
4040       pr_error s_num$&" - not possible"
4050    END REPeat chk
4055    PRINT
4060    s_adr=adr_items
4070    pk_w adr_items, s_num +1
4080    STRIP 7:PRINT "Enter default string>"\\
4090    s$=accept$("","",s_num,3)
4095    PRINT
4100    pk_$ adr_items,s$
4110    FOR i=LEN(s$) TO s_num+1:pk_b adr_items,32
4115    adr_items=even(adr_items)
4120    pk_wr adr_list,s_adr
4130    pk_w adr_list,0 : pk_w adr_list,0
4140    pk_wr adr_list,it_desc
4150    s_adr=adr_items
4155    pk_b adr_items,select_it("Type of String","Normal\Filename\Directory\Extension")
4157    PRINT
4160    pk_b adr_items,select_it("Special Characteristics","Strip Spaces\Do Not Strip Spaces")
4170    pk_wr adr_list,s_adr
4180 END DEFine
4190 :
4200 DEFine PROCedure cfg_char
4210    LOCal c_adr,byte
4220    pk_b adr_list,2
4230    PRINT
4240    pk_b adr_list,CODE(accept$("Type selection keystroke for the item","",1,-1))
4250    PRINT
4260    c_adr=adr_items
4270    pk_b adr_items,CODE(accept$("Type in default character","",1,-1))
4275    PRINT
4280    pk_wr adr_list,c_adr
4290    adr_items=even(adr_items)
4300    pk_w adr_list,0 : pk_w adr_list,0
4310    pk_wr adr_list,it_desc
4315    byte=0
4320    byte=1-select_it("Select possible characteristics\non printable characters allowed","yes\no")
4325    PRINT
4330    byte=byte+2*(1-select_it("digits allowed","yes\no"))
4335    PRINT
4340    byte=byte+4*(1-select_it("lower case letters allowed","yes\no"))
4345    PRINT
4350    byte=byte+8*(1-select_it("upper case letters allowed","yes\no"))
4355    PRINT
4360    byte=byte+16*(1-select_it("other printable characters allowed","yes\no"))
4365    PRINT
4370    byte=byte+64*(1-select_it("cursor characters allowed","yes\no"))
4372    PRINT
4375    c_adr=adr_items
4380    pk_w adr_items,byte
4390    pk_wr adr_list,c_adr
4400 END DEFine
4410 :
4420 DEFine PROCedure cfg_code
4430    LOCal c_adr
4440    pk_b adr_list,4
4450    PRINT
4460    pk_b adr_list,CODE(accept$("Type selection keystroke for the item","",1,-1))
4470    PRINT
4480    REPeat chk
4490       c_val$=accept$("Enter default code value (0-255)","0",3,0)
4500       IF c_val$=CHR$(27) THEN RETurn
4510       c_val="0"&c_val$
4520       SELect ON c_val=0 TO 255:EXIT chk
4530       pr_error c_val$&" - not possible"
4540    END REPeat chk
4545    PRINT
4550    c_adr=adr_items
4560    pk_b adr_items,c_val
4565    adr_items=even(adr_items)
4570    pk_wr adr_list,c_adr
4580    pk_w adr_list,0:pk_w adr_list,0
4590    pk_wr adr_list,it_desc
4600    selkey=select_it("Allow selection keystrokes","no\yes")
4605    PRINT
4610    x=0
4612    adr_items=even(adr_items)
4615    c_adr=adr_items
4620    REPeat loop2
4630       x=x+1
4640       REPeat chk
4650          c_val$=accept$("Enter code (0-255) for selection #"&x&" or press ESC\to finish code list","0",3,0)
4660          IF c_val$=CHR$(27) THEN EXIT loop2
4670          c_val="0"&c_val$
4680          SELect ON c_val=0 TO 255:EXIT chk
4690          pr_error c_val$&" - not possible"
4700       END REPeat chk
4705       pk_b adr_items,c_val
4710       PRINT
4720       IF selkey
4730          pk_b adr_items,CODE(accept$("Type code selection keystroke","",1,-1))
4735          PRINT
4740       ELSE
4750          pk_b adr_items,0
4760       END IF
4770       pk_$ adr_items,accept$("Enter string for this code","",30,3)
4775       PRINT
4780       adr_items=even(adr_items)
4790    END REPeat loop2
4800    pk_w adr_items,-1
4810    pk_wr adr_list,c_adr
4820 END DEFine
4830 :
4840 :
4850 DEFine PROCedure value_poke(type, addr, value)
4860   LOCal t
4870   :
4880   t = type
4890   SELect ON t
4900     =  8: pk_b addr, value
4910     = 10: pk_w addr, value
4920     = 12: pk_l addr, value
4930   END SELect
4940 END DEFine value_poke
4950 :
4960 :
10000 REMark ----- general functions ---------------------------------------
10010 DEFine FuNction accept$(info$,deft$,max_len,range)
10020   LOCal first,x,loop,pos,xpos,ypos,key$(1),key,loop,chblk,rang(1),default$
10025   default$=deft$
10030   SELect ON range
10040      =0:rang(0)=48:rang(1)=57
10050      =1:rang(0)=45:rang(1)=57
10060      =2:rang(0)=65:rang(1)=90
10070      =3,-1:rang(0)=32:rang(1)=191
10080   END SELect
10085   PAPER 7:INK 0
10087   IF info$<>"" THEN
10090     REPeat loop
10100       x="\" INSTR info$
10110       IF x=0 THEN EXIT loop
10120       PRINT info$(1 TO x-1)
10130       info$=info$(x+1 TO)
10140     END REPeat loop
10150     PRINT info$;"> ";
10155   END IF
10160   chblk=CHBASE(#1):STRIP 4
10170   pos=1:xpos=PEEK_W(chblk+34) DIV PEEK_W(chblk+38):ypos=PEEK_W(chblk+36) DIV PEEK_W(chblk+40)
10175   first=1
10180   REPeat loop
10190      AT ypos,xpos:PRINT default$;:CLS 4
10200      AT ypos,xpos+pos-1
10205      IF first=0 AND range=-1 THEN EXIT loop
10210      CURSEN:key$=INKEY$(#1,-1):CURDIS
10220      key=CODE(key$)
10230      SELect ON key
10240        =27:default$=key$:EXIT loop
10250        =10:EXIT loop
10260        =192:IF pos>1 THEN pos=pos-1
10270        =200:IF pos<=LEN(default$) THEN pos=pos+1
10280        =194:IF pos>1 THEN
10290                IF pos<LEN(default$)
10300                   default$=default$(1 TO pos-2)&default$(pos TO)
10310                ELSE
10320                   default$=default$(1 TO pos-2)
10330                END IF
10340                pos=pos-1
10350              END IF
10360        =202:IF LEN(default$)>0 THEN
10370                IF pos<LEN(default$) THEN
10380                   default$=default$(1 TO pos-1)&default$(pos+1 TO)
10390                ELSE
10400                   default$=default$(1 TO pos-1)
10410                END IF
10420             END IF
10425        =rang(0) TO rang(1)
10427             IF first THEN default$=""
10430             IF LEN(default$)<max_len
10440                IF pos<LEN(default$)
10450                   default$=default$(1 TO pos-1)&key$&default$(pos TO)
10460                ELSE
10470                   default$=default$&key$
10480                END IF
10490                pos=pos+1
10500             END IF
10510      END SELect
10515      first=0
10520   END REPeat loop
10530   PRINT
10540   RETurn default$
10550 END DEFine
10560 :
10570 DEFine PROCedure pr_error(SRING$)
10580   STRIP 2:INK 7:PRINT SRING$:STRIP 7:INK 0
10590 END DEFine
10600 :
10610 DEFine FuNction select_it(info$,items$)
10620   LOCal it$(9,30)
10625   PAPER 7:INK 0
10630   cnt=0
10640   REPeat loop
10650     x="\" INSTR info$
10660     IF x=0 THEN EXIT loop
10670     PRINT info$(1 TO x-1)
10680     info$=info$(x+1 TO)
10690   END REPeat loop
10700   PRINT info$;"> ";
10710   REPeat loop
10720     x="\" INSTR items$
10730     IF x=0 THEN EXIT loop
10740     it$(cnt)=items$(1 TO x-1)
10750     items$=items$(x+1 TO)
10751     cnt=cnt+1
10755   END REPeat loop
10757   it$(cnt)=items$
10760   chblk=CHBASE(#1):STRIP 4
10770   xpos=PEEK_W(chblk+34) DIV PEEK_W(chblk+38):ypos=PEEK_W(chblk+36) DIV PEEK_W(chblk+40)
10775   x=0
10780   REPeat loop
10790      AT ypos,xpos:PRINT it$(x);:CLS 4
10800      CURSEN:key$=INKEY$(#1,-1):CURDIS
10810      key=CODE(key$)
10820      SELect ON key
10825         =27:x=27:EXIT loop
10830         =32:x=x+1
10840         =10:EXIT loop
10850         =192,208:x=x-1
10860         =200,216:x=x+1
10870      END SELect
10880      IF x<0 THEN x=cnt
10890      IF x>cnt THEN x=0
10900    END REPeat loop
10910    PRINT
10920    RETurn x
10930 END DEFine
